/* ---------------------------------------------------------------- */
/* --- kcnfs 2003/02/12                                         --- */
/* ---------------------------------------------------------------- */
/* --- author : Gilles DEQUEN                                   --- */
/* --- dequen@laria.u-picardie.fr                               --- */
/* ---------------------------------------------------------------- */

#ifndef KCNFS_HEADER
#define KCNFS_HEADER

/* ---------------------------------------------------------------- */

#define MAXCLAUSE 100000
#define MAXLENGTH 15
/* ---------------------------------------------------------------- */
#define VERSION "03/02/12"
#define UNDEF -1
#define SAT 1
#define UNSAT 0
#define TRUE 1
#define FALSE 0
#define FIX 2
#define EOC 0
#define LIMINF 3
#define LIMITK 250
#define REDONDANT 2
#define SUBSUMEE 3
#define absolute(v) (( v >= 0) ? v : -v)
#define sat() (_s_s == nb_clause)
#define PONDERE 5
/* ---------------------------------------------------------------- */


/* ---------------------------------------------------------------- */
long int bchs = 0;

int *wcl_p[MAXVAR+1], *wcl_n[MAXVAR+1];
int o_p[MAXVAR+1], o_n[MAXVAR+1];
float w_p[MAXVAR+1], w_n[MAXVAR+1];
float scl_p[MAXVAR+1][MAXLENGTH+1];
float scl_n[MAXVAR+1][MAXLENGTH+1];
int scr_p[MAXVAR+1], scr_n[MAXVAR+1], _scr = 0;
int ocl_p[MAXVAR+1][MAXLENGTH+1], ocl_n[MAXVAR+1][MAXLENGTH+1];
boolean v_status[MAXVAR+1], c_status[MAXCLAUSE], v_tf[MAXVAR+1];
byte p3[MAXVAR], p2[MAXVAR], n3[MAXVAR], n2[MAXVAR];
byte c_size[MAXCLAUSE];
int v_cv[MAXVAR+1], v_tmp[MAXVAR+1], _v_cv = 0, _v_tmp = 0;
int s_uc[MAXCLAUSE], _s_uc = 0;
int c_cc[MAXCLAUSE], _c_cc = 0;
int s_v[MAXVAR+MAXVAR], _s_v = 0;
int s_c[MAXCLAUSE], _s_c = 0;
int s_s[MAXCLAUSE], _s_s = 0;
int s_alpha[MAXVAR], _s_alpha = 0;
int s_bf[MAXVAR], _s_bf = 0;
int s_tmp[MAXVAR], _s_tmp = 0;
int s_choice[MAXCLAUSE], _s_choice = 0, choice;
int _c_fix = 0, prof = 0;
int fix_depth = 5, _fix_depth = 0, next_depth = 0;
boolean resolvant = ON;
int binary[MAXVAR+1], v_binary[MAXVAR+1];
int _v_binary = 0, _binary = 0;
float cum_eval, norm, _norm[MAXLENGTH+1];
float pondere[MAXLENGTH+1];
int c2h3 = 7, c1h3 = 3, c3h1 = 10, c3h2 = 3, c3h3 = MAXVAR;
int fix3 = 53, fix2 = 55, lim_bf = 50;
int leaders = 3, breakfix = 10, filter = 10;
int s_choice_h0[MAXVAR], _s_choice_h0 = 0;
int s_choice_h2[MAXVAR], _s_choice_h2 = 0;
int s_choice_h3[MAXVAR], _s_choice_h3 = 0;
int s_choice_h4[MAXVAR], _s_choice_h4 = 0;
byte divide = OFF;
int _divide = 0;
char f_divide[50] = "cnf";
boolean _b_fix3 = OFF, _b_fix2 = OFF, _b_fix_depth = OFF, _b_filter = OFF, _b_c3h1 = OFF;
boolean _b_c2h3 = OFF, _b_c1h3 = OFF, _b_lim_bf = OFF, _b_c3h2 = OFF, _b_c3h3 = OFF;
int solution[MAXVAR];
/* ---------------------------------------------------------------- */
boolean unrename_to_cnf(char *);
boolean to_cnf(char *);
void print_clause(int *);
void print_context (void);
void print_formulae (void);
void for_k(void);
struct cnf* built_clause(int *);
struct wcl* built_addr(struct cnf *);
int copy_cl(int *, int *);
int get_length(int *);
float exposant_v(int, int);
void built_main_struct(void);
byte get_resolvant(int *, int *, int *);
boolean add_res(int *);
byte c_cmp(int *, int *);
byte check_res(int *);
boolean mk_resolvant(void);
void values(void);
boolean readcnf (char *);
void free_dynamic(void);
int occ_p_k(register int);
int occ_n_k(register int);
int occ_p_l(register int);
int occ_n_l(register int);
void light_reduce(register int *);
boolean reduce(register int *);
void satisfy(register int *);
boolean up_i(void);
boolean up_alpha_i(void);
boolean up(void);
boolean up_alpha(void);
boolean reduce_n(register int);
boolean reduce_p(register int);
boolean reduce_alpha_p(register int);
boolean light_reduce_alpha_n(register int);
boolean light_reduce_p(register int);
boolean light_reduce_n(register int);
void fix(register int);
boolean deep_fix_p_k(register int);
boolean deep_fix_n_k(register int);
boolean deep_fix_k(register int);
boolean deep_fix_p_l(register int);
boolean deep_fix_n_l(register int);
boolean deep_fix_l(register int);
boolean light_deep_fix_p_k(register int);
boolean light_deep_fix_n_k(register int);
boolean light_deep_fix_k(register int);
boolean light_deep_fix_p_l(register int);
boolean light_deep_fix_n_l(register int);
boolean light_deep_fix_l(register int);
float h1(register int);
int h1_light(register int);
boolean fix_h1_h0(register int);
boolean on_h0(register int);
float score_n(register int);
float score_p(register int);
float score_h3_p(register int);
float score_h3_n(register int);
float h3(register int);
boolean fix_h3(register int);
boolean on_h2(register int);
float score_h4_p(register int);
float score_h4_n(register int);
float h4(register int);
boolean fix_h4(register int);
boolean on_h3(register int);
float h2(register int);
boolean fix_h2(register int);
boolean on_h1(register int);
void get_bf(register int);
void back_fix(register int);
boolean on_bf(void);
boolean on_alpha(void);
boolean fix_h0_k(register int);
boolean fix_h0_l(register int);
boolean fix_h1_l(register int);
boolean fix_h1_k(register int);
void normalize(void);
boolean fix_h0_light(register int);
void to_choice(void);
void to_choice_l(void);
void to_choice_h0_l(void);
boolean built_candidates(register int);
boolean node_k(void);
boolean node_l(void);
void built_cl2(void);
boolean is_sat_k(void);
byte is_sat_dk(void);
boolean is_sat_l(void);
byte is_sat_dl(void);

#endif /*KCNFS_HEADER*/
