/***************************************************************
Copyright (C) 2005  Yannet Interian and Gabriel Corvera

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
******************************************************************/ 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <limits.h>
#include <signal.h>
#include <getopt.h>
#include <unistd.h>

#include <sys/times.h>
#include <sys/time.h>
#include <time.h>
#include "k-qbf.h"

#define MAXLINE 10000000

#define MAXATOM 20000
#define STOREBLOCK 2000000	/* size of block to malloc each time */
#define MAXCLAUSE 10000000
#define TRUE 1
#define FALSE 0

#define MAXLENGTH 500           /* maximum number of literals which can be
				   in any clause */

#define ABS(x) ((scratch=(x))>0?(scratch):(-scratch))


struct Formula{
  int *clauseU[MAXCLAUSE];
  int *clauseE[MAXCLAUSE];
  int numclause;
  int numatom;
  int numatomU;
  int numatomE;
  int atoms[MAXATOM];//1 if they are in the Universal, 2 in the Existential
  int atomU[MAXATOM];
  int atomE[MAXATOM];
  int sizeU[MAXCLAUSE];
  int sizeE[MAXCLAUSE];
  int *occurence[2*MAXATOM+1];
  int numoccurence[2*MAXATOM+1];
};

struct Subformula{
  int clause[MAXCLAUSE]; //1 if it is 0 if it is not
  int numclause;
  int numocc[2*MAXATOM+1]; //numoccurrences in the subformula
  int score;
};

struct SOL{
  int solution[MAXATOM+1];
  int score;
  int numtrue;
  int mix_score;
};


FILE * CutCommentsFile(char *name);
//void processFile(FILE *fp);
void processFile(FILE *fp, char *name);
void TwoaltQBFinput( char *name);
void occurrences();

void printingFormula();
void printingAtoms();
void printingOccurrences();


//walkQBF.c
void initialization();
int minsatWalk();

void PrintAssignmentU();
void PrintSubformula();

int parsecommandline(int argc, char **argv);
void assignment2subformula();
int balanceSub();
void computeDegrees();


void ExitSubformula(int a);

void WITHwalkminsat();
int call_kcnfs(int numsubform);


int runminsat(void);
void assignment2subformula_1();
extern void free_dynamic(void);

/**Externs KCNFS**/
extern int ssat[KMAXCLAUSE][KMAXLENGTH+1];

extern struct wcl *_wcl_p[MAXVAR+1], *_wcl_n[MAXVAR+1];
extern struct cnf *_ssat;
extern byte v_icu[MAXVAR+1], v_icu_l[MAXVAR+MAXVAR+2];
extern boolean _b_leaders, _b_breakfix, cnf2;
extern struct cnf* built_clause(int *c);
extern struct wcl* built_addr(struct cnf *c);

enum heuristics { RANDOM, WORST, BALANCE, MIXED, MIXED_2, MIXED_BLOCK, BEST_AND_SECOND, MIXED_BALANCE};
int heuristicParam;
